#include "WinningThePresidency.h"
#include "Testing/WinningThePresidencyTests.h"
#include "grid.h"
using namespace std;

/**
 * Given a list of states, a target number of electoral votes, and a start index into that list
 * of states, returns the minimum number of popular votes you'd need to get that many electoral
 * votes, along with which states you'd use to make that target.
 *
 * If it's not possible to hit the target number of electoral votes, you should return a MinInfo
 * struct that has the number of popular votes set to the constant kNotPossible. The set of
 * associated states can be whatever you'd like it to be in that case.
 *
 * When you're implementing your preliminary version of this function, you MUST NOT add any extra
 * parameters to this function, and you MUST NOT make this a wrapper around another helper
 * function. You should only edit the signature of this function when you're adding in
 * memoization.
 *
 * @param electoralVotes The target number of electoral votes to hit.
 * @param startIndex The starting index into the Vector of which states you're allowed to use.
 * @param states All the states participating in the election.
 * @return Information about the fewest number of popular votes needed to hit the target number
 *         of electoral votes using only states from index startIndex and beyond.
 */
MinInfo minPopularVoteToGetAtLeast(int electoralVotes,
                                   int startIndex,
                                   const Vector<State>& states) {
    /* TODO: Delete this line and the next four, then implement this function. */
    (void) electoralVotes;
    (void) startIndex;
    (void) states;
    return {};
}

/**
 * Given a list of states, returns information about the minimum number of
 * popular votes needed to be elected President of the United States.
 *
 * @param states All the states that participated in the election.
 * @return Information about how many votes you'd need to be elected.
 */
MinInfo minPopularVoteToWin(const Vector<State>& states) {
    /* TODO: Delete this line and the next two, then implement this function. */
    (void) states;
    return {};
}






/* * * * * * Test Cases Below This Point * * * * * */

/* These tests are designed to test your top-level minPopularVoteToWin function. You'll
 * need to add in more test cases here, but you shouldn't need to change any of these tests
 * at any point during your design.
 */
ADD_TEST("Provided Test: One state.") {
    Vector<State> states = {
        { "Denial", 1, 1 }
    };

    auto soln = minPopularVoteToWin(states);
    EXPECT_EQUAL(soln.popularVotesNeeded, 1);
    EXPECT_EQUAL(soln.statesUsed, states);
}

ADD_TEST("Provided Test: States empty") {
    Vector<State> states;

    auto soln = minPopularVoteToWin(states);
    EXPECT_EQUAL(soln.popularVotesNeeded, kNotPossible);
    EXPECT_EQUAL(soln.statesUsed, states);
}

ADD_TEST("Provided Test: Two states") {
    Vector<State> states = {
        { "A", 4, 500 },
        { "B", 3, 400 },
    };

    auto soln = minPopularVoteToWin(states);
    EXPECT_EQUAL(soln.popularVotesNeeded, 251);
    EXPECT_EQUAL(soln.statesUsed.size(), 1);
    EXPECT(soln.statesUsed.contains(states[0]));
}

ADD_TEST("Provided Test: Three states") {
    Vector<State> states = {
        { "A", 4, 500 },
        { "B", 3, 499 },
        { "C", 2, 100 },
    };

    auto soln = minPopularVoteToWin(states);
    EXPECT_EQUAL(soln.popularVotesNeeded, 301);
    EXPECT_EQUAL(soln.statesUsed.size(), 2);
    EXPECT(soln.statesUsed.contains(states[1]));
    EXPECT(soln.statesUsed.contains(states[2]));
}
